VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsArchiveByUNLHA32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************************************************
'   LHAt@Ck@\(UNLHA32.dllK{)                        clsArchiveByUNLHA32(Class)
'
'   쐬:㎡  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelłd!]
'***************************************************************************************************
'   [QƐݒ]
'   EMicrosoft Scripting Runtime
'***************************************************************************************************
' ύXt Rev   ύXe---------------------------------------------------------------------->
' 06/05/06(1.0.0)VK쐬
' 17/09/24(2.0.0)NXڍs(modArchiveByUNLHA32clsArchiveByUNLHA32)
'***************************************************************************************************
Option Explicit
'===================================================================================================
Private Const g_cnsLZH As String = ".lzh"
Private Const g_cnsEXE As String = ".exe"
Private Const MAX_PATH As Long = 260                                ' pX񒷏
'---------------------------------------------------------------------------------------------------
' UNLHA32̃o[W擾(UNLHA32)
Private Declare Function UnlhaGetVersion Lib "UNLHA32.dll" () As Integer
' UNLHA32̓ԂmF(UNLHA32)
Private Declare Function UnlhaGetRunning Lib "UNLHA32.dll" () As Boolean
' LHAk𑀍삷API(UNLHA32)
Private Declare Function Unlha Lib "UNLHA32.dll" _
    (ByVal lhWnd As Long, _
     ByVal szCmdLine As String, _
     ByVal szOutPut As String, _
     ByVal wSize As Long) As Long
' EBhEnhԂ
Private Declare Function FindWindow Lib "USER32.dll" Alias "FindWindowA" _
    (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long
'---------------------------------------------------------------------------------------------------
Private g_strWindowCaption As String                                ' eEBhE^Cg

'***************************************************************************************************
'    NX 
'***************************************************************************************************
'* @FClass_Initialize
'* @\@@FNX
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Ȃ)
'* @@F(Ȃ)
'---------------------------------------------------------------------------------------------------
'* 쐬@F2017N0924
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Sub Class_Initialize()
    '-----------------------------------------------------------------------------------------------
    ' EBhE݂Excel.Application^Cgɐݒ
    g_strWindowCaption = Application.Caption
End Sub

'***************************************************************************************************
'    ǑĂяovV[W(Friend) 
'***************************************************************************************************
'* @FArchiveByUNLHA32
'* @\@@FLHAt@Ck@\(UNLHA32.dllK{)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = k̃t@C(String)          RefQ
'* @@@@@Arg2 = kΏۂ̃t@C(Variant)       ̏ꍇ͔zZbg
'* @@@@@Arg3 = G[bZ[W(Atring)            RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2006N0506
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function ArchiveByUNLHA32(ByRef strTarget As String, _
                                 ByRef vntSource As Variant, _
                                 ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim strCommand As String                                        ' R}hC
    ArchiveByUNLHA32 = False
    '-----------------------------------------------------------------------------------------------
    ' kwlyъ`FbN(+R}hCҏW)
    If Not FP_CheckArchive(strTarget, _
                           vntSource, _
                           strCommand, _
                           strErrMSG) Then
        Exit Function
    End If
    '-----------------------------------------------------------------------------------------------
    ' UNLHA32R}hs
    ArchiveByUNLHA32 = LetCommandByUNLHA32(strCommand, strErrMSG)
    On Error GoTo 0
End Function

'***************************************************************************************************
'* @FLetCommandByUNLHA32
'* @\@@FUNLHA32R}hs(CӃR}hC)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = R}hC(String)
'* @@@@@Arg2 = G[bZ[W(Atring)            RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2017N0924
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function LetCommandByUNLHA32(ByVal strCommand As String, _
                                    ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim hWnd As Long                                                ' EBhEnhl
    Dim strMSG_Base As String                                       ' bZ[Wx[X
    Dim strBuffer As String                                         ' Work
    LetCommandByUNLHA32 = False
    On Error GoTo LetCommandByUNLHA32_ERROR
    '-----------------------------------------------------------------------------------------------
    strMSG_Base = "kR|[lgUNLHA32CXg[Ă܂B"
    ' UNLHA32.dll̑݊mF(o[W擾s)
    Call UnlhaGetVersion
    '-----------------------------------------------------------------------------------------------
    strMSG_Base = "kR|[lgUNLHA32œ쒆łB"
    ' UNLHA32.dll̓󋵊mF
    If UnlhaGetRunning Then
        strErrMSG = strMSG_Base
        Exit Function
    End If
    DoEvents                    ' ꂪȂƓsɂȂ悤łH
    '-----------------------------------------------------------------------------------------------
    strMSG_Base = "UNLHA32Ɏs܂B"
    ' EBhEnh擾
    hWnd = FP_GetWindowHwnd
    strBuffer = String(256, Chr(0))
    ' R}hCɏ]UNLHA𑀍
    If Unlha(hWnd, strCommand, strBuffer, Len(strBuffer)) = 0& Then
        LetCommandByUNLHA32 = True
    Else
        strErrMSG = Left(strBuffer, InStr(1, strBuffer, Chr(0)) - 1)
    End If
    On Error GoTo 0
    Exit Function
    
'===================================================================================================
LetCommandByUNLHA32_ERROR:
    strErrMSG = strMSG_Base & vbCrLf & Err.Description
    On Error GoTo 0
End Function

'***************************************************************************************************
'    Tu(Private) 
'***************************************************************************************************
'* @FFP_CheckArchive
'* @\@@Fkwlyъ`FbN(+R}hCҏW)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = k̃t@C(String)          RefQ
'* @@@@@Arg2 = kΏۂ̃t@C(Variant)       ̏ꍇ͔zZbg
'* @@@@@Arg3 = ҏWR}hC(String)      RefQ
'* @@@@@Arg4 = G[bZ[W(String)            RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2006N0506
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Function FP_CheckArchive(ByRef strTarget As String, _
                                 ByRef vntSource As Variant, _
                                 ByRef strCommand As String, _
                                 ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim objFSO As FileSystemObject                                  ' FileSystemObject
    Dim lngIx As Long                                               ' e[uINDEX
    Dim strPathName As String                                       ' tH_(Work)
    Dim strFilename As String                                       ' t@C(Work)
    Dim strExtL As String                                           ' gq()
    FP_CheckArchive = False
    Set objFSO = New FileSystemObject
    '-----------------------------------------------------------------------------------------------
    ' kt@C`FbN
    strFilename = Trim(strTarget)
    ' uN
    If strFilename = "" Then
        strErrMSG = "o̓t@Cw肳Ă܂B"
        Set objFSO = Nothing
        Exit Function
    End If
    ' tpXłȂΖ{ubÑtH_w
    If ((Left$(strFilename, 2) <> "\\") And (Mid$(strFilename, 2, 2) <> ":\")) Then
        strPathName = ThisWorkbook.Path
        strTarget = objFSO.BuildPath(strPathName, strFilename)
    Else
        strTarget = strFilename
        strFilename = objFSO.GetFileName(strTarget)
        strPathName = Left$(strTarget, Len(strTarget) - Len(strFilename) - 1)
    End If
    ' tH_݂邩
    If Not objFSO.FolderExists(strPathName) Then
        strErrMSG = "o̓t@C̃tB_݂܂B" & vbCrLf & strPathName
        Set objFSO = Nothing
        Exit Function
    End If
    strExtL = LCase(Right(strTarget, 4))                            ' gq
    ' gq̔(w̏ꍇ͋Iɕt)
    If ((strExtL <> g_cnsLZH) And (strExtL <> g_cnsEXE)) Then
        strTarget = strTarget & g_cnsLZH
        strFilename = strFilename & g_cnsLZH
    End If
    '-----------------------------------------------------------------------------------------------
    ' UNLHÃR}hCҏWJn
    strCommand = "a "
    ' 𓀏Ɏw肩˃XCb`ǉ
    If strExtL = g_cnsEXE Then
        strCommand = strCommand & "-gw4 "
    End If
    strCommand = strCommand & """" & strTarget & """"
    '-----------------------------------------------------------------------------------------------
    ' kΏۃt@C`FbN
    If IsArray(vntSource) Then
        lngIx = 0
        ' t@Cw(tH_ɂ͑ΉĂȂ)
        Do While lngIx <= UBound(vntSource)
            strFilename = Trim(vntSource(lngIx))
            ' ݊mF
            If Not objFSO.FileExists(strFilename) Then
                strErrMSG = "̓t@C݂܂B" & vbCrLf & strFilename
                Set objFSO = Nothing
                Exit Function
            Else
                strCommand = strCommand & " """ & strFilename & """"
            End If
            ' ̃t@C
            lngIx = lngIx + 1
        Loop
    Else
        strFilename = Trim(vntSource)
        ' w肩
        If strFilename = "" Then
            strErrMSG = "̓t@Cw肳Ă܂B"
            Set objFSO = Nothing
            Exit Function
        ElseIf objFSO.FolderExists(strFilename) Then
            ' tH_w̏ꍇ͔zSĂi[
            strCommand = strCommand & " -d1 """ & objFSO.GetParentFolderName(strFilename) & "\"" " & _
                objFSO.GetFileName(strFilename)
        ElseIf objFSO.FileExists(strFilename) Then
            ' t@Cw
            strCommand = strCommand & " """ & strFilename & """"
        Else
            ' ws
            strErrMSG = "̓t@C݂܂B" & vbCrLf & strFilename
            Set objFSO = Nothing
            Exit Function
        End If
    End If
    '-----------------------------------------------------------------------------------------------
    ' kt@Cɑ݂鎞͈U폜
    If objFSO.FileExists(strTarget) Then
        On Error Resume Next
        objFSO.DeleteFile strTarget, True
        ' G[
        If Err.Number <> 0 Then
            strErrMSG = "o̓t@C̎O폜Ɏs܂B" & vbCrLf & Err.Description
            On Error GoTo 0
            Set objFSO = Nothing
            Exit Function
        End If
        On Error GoTo 0
    End If
    '-----------------------------------------------------------------------------------------------
    Set objFSO = Nothing
    FP_CheckArchive = True
End Function

'***************************************************************************************************
'* @FFP_GetWindowHwnd
'* @\@@FEBhEnh擾
'---------------------------------------------------------------------------------------------------
'* Ԃl@FEBhEnh(Long)
'* @@F(Ȃ)
'---------------------------------------------------------------------------------------------------
'* 쐬@F2006N0506
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Function FP_GetWindowHwnd() As Long
    '-----------------------------------------------------------------------------------------------
    ' ExcelEBhE
    Select Case g_strWindowCaption
        Case "", Application.Caption
            ' ExcelEBhEƔf
            FP_GetWindowHwnd = Application.hWnd
        Case Else
            ' [U[tH[Ɣf
            On Error Resume Next
            FP_GetWindowHwnd = FindWindow("ThunderDFrame", g_strWindowCaption)
            ' G[ExcelEBhEƔf
            If Err.Number <> 0 Then
                FP_GetWindowHwnd = Application.hWnd
            End If
            On Error GoTo 0
    End Select
End Function

'***************************************************************************************************
'    vpeB 
'***************************************************************************************************
'   eEBhE^Cg(String)
'---------------------------------------------------------------------------------------------------
Friend Property Let prpWindowCaption(ByVal Value As String)
    '-----------------------------------------------------------------------------------------------
    g_strWindowCaption = Value
End Property

'------------------------------------------<< End of Source >>--------------------------------------
